// EE231002 Lab05. Blackjack probabilities
// 108061112, 林靖
// Oct. 18, 2019

#include <stdio.h>		// Standard input and output library
#include <stdlib.h>		// Standard library for performing rand()

int main(void)			// The function called at program startup
{
	short target;		// For each particular target points
	long numExpr;		// Number of experiments performed for each target pt
	long ttlSuccess;	// Total number of successes out of 100k experiments
	long ttlDeal;		// Total number of cards dealt upon all successful tries
	float probSuccess;	// Probability of success in 100k experiments
	float avgDeal;		// Average number of cards dealt upon successful tries
	short randomVal;	// Face value of the card randomly drawn
	short cumuDeal;		// Cumulative number of cards dealt in single experiment
	short sumPt;		// Summation of points in single experiment

	printf("Points  Probability  #Cards\n");			// Fixed table header
	for (target = 4; target <= 21; target++) {			// Compute from 4 to 21
		ttlSuccess = 0;									// Reinitialize counters
		ttlDeal = 0;									// for each target pt.
		for (numExpr = 0; numExpr < 100000; numExpr++) {// Play many times
			sumPt = 0;						// Initialize for single experiment
			randomVal = rand() % 13 + 1;	// Randomly draw a card
			switch (randomVal) {			// To determine value of drawn card:
				case 11:					// Jacks,		
				case 12:					// queens, and
				case 13:					// kings
					sumPt += 10;			// are treated as 10 pt.
					break;
				case 1:						// Ace is always 11 pt in first deal
					sumPt += 10;			// Add 10 here, and add 1 in line 36
				default:					// The cards 2 to 10
					sumPt += randomVal;		// have the face values.
			}			   // The loop below terminates when a conclusive result
			for (cumuDeal = 2; sumPt < target; cumuDeal++) {	 // is obtained.
				randomVal = rand() % 13 + 1;	// Randomly draw a card
				switch (randomVal) {			// To determine the value:
					case 11:					// Jacks,
					case 12:					// queens, and
					case 13:					// kings
						sumPt += 10;			// are treated as 10 pt.
						break;
					case 1:
						if (sumPt + 11 <= 21) {	// If the total would not exceed
							sumPt += 10;		// 21, ace can have 11 pt. (10
						}						// extra over the original 1 pt)
					default:					// The cards 2 to 10
						sumPt += randomVal;		// have the face values.
				}
				if (sumPt == target) {			// If reach exactly the target,
					++ttlSuccess;				// then it's a success.
					ttlDeal += cumuDeal;		// Add cumulated cards into the
				}								// total number of cards dealt.
			}
		}
		probSuccess = 100.f * ttlSuccess / numExpr;		// Percentage of success
		avgDeal = 1.f * ttlDeal / ttlSuccess;			// Calculate the average
		printf("%3.hi%12.2f%%%10.2f\n", target, probSuccess, avgDeal);
	}				// Print out the results in columns aligning the table head
	return 0;		// Indicates normal program termination
}
